Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ExecutionEngineFacade.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ExecutionEngineFacade.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ExecutionEngineFacade.cs	(revision 4042)
@@ -53,6 +53,6 @@
 
     public ResponseObject<SerializedJob> 
-      GetLastSerializedResult(Guid jobId, bool requested) {
-      return jobManager.GetLastSerializedJobResultOf(jobId, requested);
+      GetLastSerializedResult(Guid jobId, bool requested, bool snapshot) {
+      return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
     }
 
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/HeuristicLab.Hive.Server.Core-3.2.csproj	(revision 4042)
@@ -120,4 +120,5 @@
     </Compile>
     <Compile Include="Settings.cs" />
+    <Compile Include="SpringTransaction.cs" />
   </ItemGroup>
   <ItemGroup>
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs	(revision 4042)
@@ -105,4 +105,5 @@
       ResponseList<JobDto> response = new ResponseList<JobDto>();
       response.List = new List<JobDto>(DaoLocator.JobDao.FindWithLimitations(jobState, offset, count));
+      response.Success = true;
       return response;
     }
@@ -237,11 +238,14 @@
     }
 
+    //Requested means: there MUST be a job result which gets sent back
     public ResponseObject<SerializedJob>
-      GetLastSerializedJobResultOf(Guid jobId, bool requested) {
+      GetLastSerializedJobResultOf(Guid jobId, bool requested, bool snapshot) {
       ResponseObject<SerializedJob> response =
         new ResponseObject<SerializedJob>();
 
       JobDto job = DaoLocator.JobDao.FindById(jobId);
-      if (requested && (job.State == State.requestSnapshot || job.State == State.requestSnapshotSent)) {
+
+      //if it's a snapshot but the result hasn't reached the server yet...
+      if (snapshot && (job.State == State.requestSnapshot || job.State == State.requestSnapshotSent)) {
         response.Success = true;
         response.StatusMessage = ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE;
@@ -250,10 +254,21 @@
       }
 
+      //if it's NOT a snapshot, NEITHER request NOR is it finished
+      if(!requested && !snapshot && job.State != State.finished) {      
+        response.Success = true;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE;
+
+        return response;
+      }
+
+      //every other case - snapshot, job finished or it's requested
       response.Success = true;
       response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_RESULT_SENT;
       response.Obj = new SerializedJob();
       response.Obj.JobInfo = job;
+
       response.Obj.SerializedJobData =
         DaoLocator.JobDao.GetBinaryJobFile(jobId);
+
       return response;
     }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 4042)
@@ -122,7 +122,7 @@
     }
 
-    public ResponseObject<SerializedJob> GetLastSerializedJobResultOf(Guid jobId, bool requested) {
+    public ResponseObject<SerializedJob> GetLastSerializedJobResultOf(Guid jobId, bool requested, bool snapshot) {
       secMan.Authorize("AccessJobResults", sessionID, jobId);
-      return jobManager.GetLastSerializedJobResultOf(jobId, requested);
+      return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
     }
 
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/SpringTransaction.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/SpringTransaction.cs	(revision 4042)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/SpringTransaction.cs	(revision 4042)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Server.Core {
+  [AttributeUsage(AttributeTargets.Class | AttributeTargets.Method)]
+  public class SpringTransaction : System.Attribute{
+    public Boolean UserTransaction { get; set; }
+  }
+}
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 4042)
@@ -19,4 +19,5 @@
         Context.SubmitChanges(ConflictMode.ContinueOnConflict);
       } catch (ChangeConflictException e) {
+        
         Logger.Warn("Concurrency Exception! " + e.Message);
         foreach (ObjectChangeConflict conflict in Context.ChangeConflicts) { 
@@ -30,5 +31,7 @@
           conflict.Resolve(RefreshMode.KeepChanges);
         }
-        Context.SubmitChanges(ConflictMode.FailOnFirstConflict);
+        //next round!
+        CommitChanges();
+        //Context.SubmitChanges(ConflictMode.FailOnFirstConflict);
       }
     }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/PluginInfoDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/PluginInfoDao.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/PluginInfoDao.cs	(revision 4042)
@@ -43,12 +43,12 @@
 
     public void InsertPluginDependenciesForJob(JobDto jobDto) {
-      foreach (HivePluginInfoDto info in jobDto.PluginsNeeded) {        
+      foreach (HivePluginInfoDto info in jobDto.PluginsNeeded) {                
         PluginInfo dbpi =
-          Context.PluginInfos.Where(pi => pi.Name.Equals(info.Name) && pi.Version == info.Version).SingleOrDefault();
+          Context.PluginInfos.Where(pi => pi.Name.Equals(info.Name) && pi.Version == info.Version.ToString()).SingleOrDefault();
         if (dbpi == null) {
           dbpi = new PluginInfo {
                                   BuildDate = info.BuildDate.ToString(),
                                   Name = info.Name,
-                                  Version = info.Version
+                                  Version = info.Version.ToString()
                                 };
           Context.PluginInfos.InsertOnSubmit(dbpi);
@@ -82,5 +82,5 @@
       target.Name = source.Name;
       target.PluginId = source.Id;
-      target.Version = source.Version;      
+      target.Version = source.Version.ToString();      
 
       return target;
@@ -96,5 +96,5 @@
       target.Name = source.Name;
       target.Id = source.PluginId;
-      target.Version = source.Version;
+      target.Version = new Version(source.Version);
 
       return target;
Index: /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/MainForm.Designer.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/MainForm.Designer.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/MainForm.Designer.cs	(revision 4042)
@@ -37,5 +37,4 @@
           this.toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
           this.tsExit = new System.Windows.Forms.ToolStripMenuItem();
-          this.btnClose = new System.Windows.Forms.Button();
           this.ctxNotifyMenu.SuspendLayout();
           this.SuspendLayout();
@@ -72,10 +71,10 @@
             this.tsExit});
           this.ctxNotifyMenu.Name = "ctxNotifyMenu";
-          this.ctxNotifyMenu.Size = new System.Drawing.Size(106, 54);
+          this.ctxNotifyMenu.Size = new System.Drawing.Size(96, 54);
           // 
           // tsShowInfo
           // 
           this.tsShowInfo.Name = "tsShowInfo";
-          this.tsShowInfo.Size = new System.Drawing.Size(105, 22);
+          this.tsShowInfo.Size = new System.Drawing.Size(95, 22);
           this.tsShowInfo.Text = "&Info";
           this.tsShowInfo.Click += new System.EventHandler(this.ShowInfo);
@@ -84,42 +83,25 @@
           // 
           this.toolStripSeparator1.Name = "toolStripSeparator1";
-          this.toolStripSeparator1.Size = new System.Drawing.Size(102, 6);
+          this.toolStripSeparator1.Size = new System.Drawing.Size(92, 6);
           // 
           // tsExit
           // 
           this.tsExit.Name = "tsExit";
-          this.tsExit.Size = new System.Drawing.Size(105, 22);
+          this.tsExit.Size = new System.Drawing.Size(95, 22);
           this.tsExit.Text = "E&xit";
           this.tsExit.Click += new System.EventHandler(this.CloseApp);
           // 
-          // btnClose
-          // 
-          this.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel;
-          this.btnClose.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-          this.btnClose.Location = new System.Drawing.Point(279, 1);
-          this.btnClose.Name = "btnClose";
-          this.btnClose.Size = new System.Drawing.Size(22, 21);
-          this.btnClose.TabIndex = 2;
-          this.btnClose.Text = "X";
-          this.btnClose.UseVisualStyleBackColor = true;
-          this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
-          // 
           // MainForm
           // 
-          this.AcceptButton = this.btnClose;
           this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
           this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-          this.CancelButton = this.btnClose;
           this.ClientSize = new System.Drawing.Size(304, 166);
-          this.ControlBox = false;
-          this.Controls.Add(this.btnClose);
           this.Controls.Add(this.rtfServices);
           this.Controls.Add(this.label1);
-          this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
+          this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
           this.Name = "MainForm";
-          this.ShowInTaskbar = false;
           this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
           this.Text = "Hive Server";
-          this.TopMost = true;
+          this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MainForm_FormClosing);
           this.ctxNotifyMenu.ResumeLayout(false);
           this.ResumeLayout(false);
@@ -137,5 +119,4 @@
         private System.Windows.Forms.ToolStripSeparator toolStripSeparator1;
         private System.Windows.Forms.ToolStripMenuItem tsExit;
-        private System.Windows.Forms.Button btnClose;
     }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/MainForm.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/MainForm.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/MainForm.cs	(revision 4042)
@@ -50,4 +50,7 @@
         }
 
+        private void MainForm_FormClosing(object sender, FormClosingEventArgs e) {          
+        }
+
     }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs	(revision 4042)
@@ -9,20 +9,24 @@
 using HeuristicLab.Hive.Contracts;
 using HeuristicLab.Tracing;
+using System.Reflection;
+using HeuristicLab.Hive.Server.Core;
 
 namespace HeuristicLab.Hive.Server {
   internal class ServiceCallInterception : IMethodInterceptor {
-
     private const bool UseTransactions = true;
 
     public object Invoke(IMethodInvocation invocation) {
+      bool userTransaction = false;
+
       DateTime start = DateTime.Now;
       Logger.Info("Entering Method: " + invocation.Method.Name);
 
-      if(!ContextFactory.IsContextNull()) {
+      if (!ContextFactory.IsContextNull()) {
         Logger.Info("Not null context found - why wasn't this disposed?");
         try {
           Logger.Info("Trying to dispose");
           ContextFactory.Context.Dispose();
-        } catch (Exception e) {
+        }
+        catch (Exception e) {
           Logger.Error(e);
         }
@@ -30,49 +34,26 @@
       }
       Logger.Info("Context info: Timeout: " + ContextFactory.Context.Connection.ConnectionTimeout + " | " +
-                  ContextFactory.Context.Connection.State + " | Conn: " + ContextFactory.Context + " | HashCode is: " + ContextFactory.Context.Connection.GetHashCode());
+                  ContextFactory.Context.Connection.State + " | Conn: " + ContextFactory.Context + " | HashCode is: " +
+                  ContextFactory.Context.Connection.GetHashCode());
       Object obj = null;
 
-      /*if (invocation.Method.Name.Equals("SendStreamedJob") || invocation.Method.Name.Equals("StoreFinishedJobResultStreamed")) {        
-        ContextFactory.Context.Connection.Open();
-        if(UseTransactions) {
-          Logger.Debug("Opening Transaction");
-          ContextFactory.Context.Transaction = ContextFactory.Context.Connection.BeginTransaction(ApplicationConstants.ISOLATION_LEVEL);
-        } else {
-          Logger.Debug("Not using a Transaction");
-        }
-        try {
-          obj = invocation.Proceed();
-          Logger.Info("leaving context open for streaming");
-        }
-        catch (Exception e) {
-          Logger.Error("Exception occured during method invocation", e);              
-          ContextFactory.Context.Dispose();
-          ContextFactory.Context = null;
-        }        
-      } else { */
-        if(UseTransactions) {
-          using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
-            try {
-              Logger.Debug("Current Transaction Isolation level is: " + Transaction.Current.IsolationLevel);
-              obj = invocation.Proceed();
-              scope.Complete();
-            }
-            catch (Exception e) {
-              Logger.Error("Exception occured during method invocation", e);     
-              Logger.Error("Inner Exception: ", e.InnerException);
-            }
-            finally {
-              ContextFactory.Context.Dispose();
-              Logger.Debug("Disposed Context");
-              ContextFactory.Context = null;
-              Logger.Debug("Set Context Null");
-            }
-          }
-        } else {
+      Object[] attributes = invocation.Method.GetCustomAttributes(typeof (SpringTransaction), true);
+      foreach (Object o in attributes) {
+        SpringTransaction st = (SpringTransaction) o;
+        userTransaction = st.UserTransaction;
+      }
+      if (UseTransactions && !userTransaction) {
+        using (
+          TransactionScope scope = new TransactionScope(TransactionScopeOption.Required,
+                                                        new TransactionOptions
+                                                        {IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE})) {
           try {
-            obj = invocation.Proceed();            
+            Logger.Debug("Current Transaction Isolation level is: " + Transaction.Current.IsolationLevel);
+            obj = invocation.Proceed();
+            scope.Complete();
           }
           catch (Exception e) {
-            Logger.Error("Exception occured during method invocation", e);                          
+            Logger.Error("Exception occured during method invocation", e);
+            Logger.Error("Inner Exception: ", e.InnerException);
           }
           finally {
@@ -81,21 +62,37 @@
             ContextFactory.Context = null;
             Logger.Debug("Set Context Null");
-          }  
+          }
         }
+      }
+      else {
+        try {
+          obj = invocation.Proceed();
+        }
+        catch (Exception e) {
+          Logger.Error("Exception occured during method invocation", e);
+        }
+        finally {
+          ContextFactory.Context.Dispose();
+          Logger.Debug("Disposed Context");
+          ContextFactory.Context = null;
+          Logger.Debug("Set Context Null");
+        }
+      }
       //}       
       TimeSpan ts = DateTime.Now - start;
       if (ts.Seconds > 2) {
         Logger.Warn("Invocation took: " + ts);
-      } else if (ts.Seconds > 10) {
+      }
+      else if (ts.Seconds > 10) {
         Logger.Error("Invocation took: " + ts);
-      } else {
-        Logger.Info("Invocation took: " + ts); ;
+      }
+      else {
+        Logger.Info("Invocation took: " + ts);
+        ;
       }
       Logger.Info("Leaving Method: " + invocation.Method.Name);
-      
+
       return obj;
     }
   }
 }
-     
-  
Index: /branches/3.2/sources/HeuristicLab.PluginInfrastructure/Sandboxing/SandboxManager.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.PluginInfrastructure/Sandboxing/SandboxManager.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.PluginInfrastructure/Sandboxing/SandboxManager.cs	(revision 4042)
@@ -65,20 +65,23 @@
 
       #region permission set for sandbox
-      // Uncomment code for sandboxed appdomain
-      //pset = new PermissionSet(PermissionState.None);
-      //pset.AddPermission(new SecurityPermission(SecurityPermissionFlag.Execution));
-      //pset.AddPermission(new ReflectionPermission(ReflectionPermissionFlag.MemberAccess));
-      //FileIOPermission fPerm = new FileIOPermission(PermissionState.None);
+      //Uncomment code for sandboxed appdomain
+      pset = new PermissionSet(PermissionState.None);
+      pset.AddPermission(new SecurityPermission(SecurityPermissionFlag.Execution));
+      pset.AddPermission(new ReflectionPermission(ReflectionPermissionFlag.AllFlags));
+      FileIOPermission fPerm = new FileIOPermission(PermissionState.None);
 
-      //foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
-      //  fPerm.AddPathList(FileIOPermissionAccess.Read | FileIOPermissionAccess.PathDiscovery, plugin.Files.ToArray());
-      //}
+      foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
+        foreach (IPluginFile pluginFile in plugin.Files) {
+          fPerm.AddPathList(FileIOPermissionAccess.Read | FileIOPermissionAccess.PathDiscovery, pluginFile.Name);  
+          //fPerm.AddPathList(FileIOPermissionAccess.AllAccess, pluginFile.Name);  
+        }        
+      }
 
-      //pset.AddPermission(fPerm);
+      pset.AddPermission(fPerm);
       #endregion
 
       #region permission set of unrestricted appdomain
       // unrestricted appdomain 
-      pset = new PermissionSet(PermissionState.Unrestricted);
+      //pset = new PermissionSet(PermissionState.Unrestricted);
       #endregion
 
@@ -86,5 +89,6 @@
       //setup.PrivateBinPath = pluginDir;
       setup.ApplicationBase = AppDomain.CurrentDomain.SetupInformation.ApplicationBase;
-      AppDomain applicationDomain = AppDomain.CreateDomain(name, AppDomain.CurrentDomain.Evidence, setup, pset, CreateStrongName(Assembly.GetExecutingAssembly()));
+      AppDomain applicationDomain = AppDomain.CreateDomain(name, AppDomain.CurrentDomain.Evidence, setup, pset, new StrongName[] {CreateStrongName(Assembly.GetExecutingAssembly())});
+
       Type applicationManagerType = typeof(DefaultApplicationManager);
       DefaultApplicationManager applicationManager =
@@ -93,6 +97,6 @@
       PluginDescription[] plugins = ApplicationManager.Manager.Plugins.Cast<PluginDescription>().ToArray();
       applicationManager.PrepareApplicationDomain(apps, plugins);
-      //if (files != null && files.Count() > 0)
-        //applicationManager.LoadAssemblies(files);
+      if (files != null && files.Count() > 0)
+        applicationManager.LoadAssemblies(files);
       return applicationDomain;
     }
